#include "ProgramOutput.hpp"
#include "ProgramParameters.hpp"
#include "util.hpp"

ProgramOutput ProgramOutput::instance;

void ProgramOutput::print(FILE * output)
{
  if (!ProgramParameters::delayedOutput)
    return;
  for (auto & line : matrix)
    for (unsigned int i = 0; i < line.size(); i++)
      fprintf(output, "%s%s%s", ProgramParameters::printOutputEntropy ? ("<"+float2str(line[i].second,"%f")+">").c_str() : "", line[i].first.c_str(), i == line.size()-1 ? "\n" : "\t");
}

void ProgramOutput::addLine(FILE * output, const std::vector< std::pair<std::string, float> > & line, unsigned int index)
{
  if (!ProgramParameters::delayedOutput)
  {
    for (unsigned int i = 0; i < line.size(); i++)
      fprintf(output, "%s%s", line[i].first.c_str(), i == line.size()-1 ? "\n" : "\t");

    return;
  }

  while (matrix.size() < index+1)
    matrix.emplace_back();

  for (unsigned int i = 0; i < line.size(); i++)
  {
    if (matrix[index].size() <= i)
      matrix[index].emplace_back(line[i]);
    else if (matrix[index][i].second > line[i].second)
    {
      matrix[index][i] = line[i];
    }
  }
}

